(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/http'), require('rxjs/add/operator/map')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/common', '@angular/http', 'rxjs/add/operator/map'], factory) :
	(factory((global['angular-shorturl'] = {}),global.core,global.common,global.http));
}(this, (function (exports,core,common,http) { 'use strict';

var ShortUrlService = (function () {
    /**
     * @param {?} http
     */
    function ShortUrlService(http$$1) {
        this.http = http$$1;
    }
    /**
     * @param {?} param
     * @return {?}
     */
    ShortUrlService.prototype.load = function (param) {
        var _this = this;
        if (this.data) {
            return Promise.resolve(this.data);
        }
        var /** @type {?} */ body = { 'longUrl': param };
        var /** @type {?} */ link = 'https://www.googleapis.com/urlshortener/v1/url?key=AIzaSyAqih9e-ooMdzPBfEJvbgd5y3QLH_5wo0g';
        var /** @type {?} */ headers = new http.Headers({ 'Content-Type': 'application/json' });
        var /** @type {?} */ options = new http.RequestOptions({ headers: headers });
        return new Promise(function (resolve) {
            _this.http.post(link, body, options)
                .map(function (res) { return res.json(); })
                .subscribe(function (data) {
                _this.data = data;
                resolve(_this.data.id);
            });
        });
    };
    return ShortUrlService;
}());
ShortUrlService.decorators = [
    { type: core.Injectable },
];
/**
 * @nocollapse
 */
ShortUrlService.ctorParameters = function () { return [
    { type: http.Http, },
]; };

var ShortUrlModule = (function () {
    function ShortUrlModule() {
    }
    /**
     * @return {?}
     */
    ShortUrlModule.forRoot = function () {
        return {
            ngModule: ShortUrlModule,
            providers: [ShortUrlService]
        };
    };
    return ShortUrlModule;
}());
ShortUrlModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [
                    common.CommonModule
                ],
                declarations: []
            },] },
];
/**
 * @nocollapse
 */
ShortUrlModule.ctorParameters = function () { return []; };

exports.ShortUrlModule = ShortUrlModule;
exports.ShortUrlService = ShortUrlService;

Object.defineProperty(exports, '__esModule', { value: true });

})));
