import { Injectable, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { Headers, Http, RequestOptions } from '@angular/http';
import 'rxjs/add/operator/map';

var ShortUrlService = (function () {
    /**
     * @param {?} http
     */
    function ShortUrlService(http$$1) {
        this.http = http$$1;
    }
    /**
     * @param {?} param
     * @return {?}
     */
    ShortUrlService.prototype.load = function (param) {
        var _this = this;
        if (this.data) {
            return Promise.resolve(this.data);
        }
        var /** @type {?} */ body = { 'longUrl': param };
        var /** @type {?} */ link = 'https://www.googleapis.com/urlshortener/v1/url?key=AIzaSyAqih9e-ooMdzPBfEJvbgd5y3QLH_5wo0g';
        var /** @type {?} */ headers = new Headers({ 'Content-Type': 'application/json' });
        var /** @type {?} */ options = new RequestOptions({ headers: headers });
        return new Promise(function (resolve) {
            _this.http.post(link, body, options)
                .map(function (res) { return res.json(); })
                .subscribe(function (data) {
                _this.data = data;
                resolve(_this.data.id);
            });
        });
    };
    return ShortUrlService;
}());
ShortUrlService.decorators = [
    { type: Injectable },
];
/**
 * @nocollapse
 */
ShortUrlService.ctorParameters = function () { return [
    { type: Http, },
]; };

var ShortUrlModule = (function () {
    function ShortUrlModule() {
    }
    /**
     * @return {?}
     */
    ShortUrlModule.forRoot = function () {
        return {
            ngModule: ShortUrlModule,
            providers: [ShortUrlService]
        };
    };
    return ShortUrlModule;
}());
ShortUrlModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule
                ],
                declarations: []
            },] },
];
/**
 * @nocollapse
 */
ShortUrlModule.ctorParameters = function () { return []; };

export { ShortUrlModule, ShortUrlService };
